// help

local starttime = 6 * TICRATE + (3 * TICRATE / 4)
local finishtime = (5*TICRATE+TICRATE/2) + TICRATE/4

// xitem stuff
--local XIF_POWERITEM = 1 --is power item (affects final odds)
--local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
--local XIF_UNIQUE = 4 --only one can exist in anyone's slot
--local XIF_LOCKONUSE = 8 --locks the item slot when the item is used, slot must be unlocked manually by setting player.xItemData.xItem_itemSlotLocked to false
--local XIF_COOLDOWNINDIRECT = 16 --checks if indirectitemcooldown is 0
local XIF_COLPATCH2PLAYER = 32 --map hud patch colour to player prefcolor
local XIF_ICONFORAMT = 64 --item icon and dropped item frame changes depending on the item amount (animation frames become amount frames)

--apparently this makes shit faster? wtf?
local TICRATE = TICRATE
local MAXSKINCOLORS = MAXSKINCOLORS
local k_spinouttimer = k_spinouttimer
local k_itemamount = k_itemamount
local k_itemtype = k_itemtype
local k_rocketsneakertimer = k_rocketsneakertimer
local k_growshrinktimer = k_growshrinktimer
local k_itemroulette = k_itemroulette
local k_itemheld = k_itemheld
local k_stolentimer = k_stolentimer
local k_stealingtimer = k_stealingtimer

local patches, rollpatches, invpatches

// i will keep using this im sorry
local function DrawTeammateKartItem(teammate, v, itemX, itemY, splitindex)
	if not patches then
		patches = {
			itembg = v.cachePatch("K_ISBG"),
			itembg2 = v.cachePatch("K_ISBGD"),
			itemtimer = v.cachePatch("K_ISIMER"),
			mulsticker = v.cachePatch("K_ISMUL"),

			[KITEM_SNEAKER] = v.cachePatch("K_ISSHOE"),
			[KITEM_ROCKETSNEAKER] = v.cachePatch("K_ISRSHE"),
			[KITEM_INVINCIBILITY] = v.cachePatch("K_ISINV1"),
			[KITEM_BANANA] = v.cachePatch("K_ISBANA"),
			[KITEM_EGGMAN] = v.cachePatch("K_ISEGGM"),
			[KITEM_ORBINAUT] = v.cachePatch("K_ISORBN"),
			[KITEM_JAWZ] = v.cachePatch("K_ISJAWZ"),
			[KITEM_MINE] = v.cachePatch("K_ISMINE"),
			[KITEM_BALLHOG] = v.cachePatch("K_ISBHOG"),
			[KITEM_SPB] = v.cachePatch("K_ISSPB"),
			[KITEM_GROW] = v.cachePatch("K_ISGROW"),
			[KITEM_SHRINK] = v.cachePatch("K_ISSHRK"),
			[KITEM_THUNDERSHIELD] = v.cachePatch("K_ISTHNS"),
			[KITEM_HYUDORO] = v.cachePatch("K_ISHYUD"),
			[KITEM_POGOSPRING] = v.cachePatch("K_ISPOGO"),
			[KITEM_KITCHENSINK] = v.cachePatch("K_ISSINK"),
			[KITEM_SAD] = v.cachePatch("K_ISSAD"),
		}
		invpatches = {
				v.cachePatch("K_ISINV1"),
				v.cachePatch("K_ISINV2"),
				v.cachePatch("K_ISINV3"),
				v.cachePatch("K_ISINV4"),
				v.cachePatch("K_ISINV5"),
				v.cachePatch("K_ISINV6"),
		}
		rollpatches = {
			patches[KITEM_SNEAKER],
			patches[KITEM_BANANA],
			patches[KITEM_ORBINAUT],
			patches[KITEM_MINE],
			patches[KITEM_GROW],
			patches[KITEM_HYUDORO],
			patches[KITEM_ROCKETSNEAKER],
			patches[KITEM_JAWZ],
			patches[KITEM_SPB],
			patches[KITEM_SHRINK],
			patches[KITEM_INVINCIBILITY],
			patches[KITEM_EGGMAN],
			patches[KITEM_BALLHOG],
			patches[KITEM_THUNDERSHIELD],
		}
	end

	patches[KITEM_INVINCIBILITY] = invpatches[(leveltime/3) % 6 + 1]
	rollpatches[11] = invpatches[(leveltime/3) % 6 + 1] -- yes, it's animated even when the roulette is active
	local bg = patches.itembg
	local numberdisplaymin = 2
	local itembar = 0
	
	// for xitem shenanigans
	local roulettetime = teammate.kartstuff[k_itemroulette]
	
	local pDat = teammate.xItemData
	// xitem has a separate roulette timer lamo
	if pDat then
		roulettetime = pDat.xItem_roulette
	end

	local patch
	if roulettetime then
		// This wasnt hard at all suprisingly
		if not pDat then
			patch = rollpatches[(roulettetime/3) % #rollpatches + 1]
		else
			local av
			if xItemLib.localAvailableItems and #(xItemLib.localAvailableItems[teammate.splitscreenindex + 1]) then
				av = xItemLib.localAvailableItems[teammate.splitscreenindex + 1]
			end
			local itdat = xItemLib.func.getItemDataByName("KITEM_SNEAKER")
			--roulette animation
			if av and #av > 0 then
				itdat = xItemLib.func.getItemDataById(av[((leveltime/3 + (i+1)*2) % #av) + 1])
			end
			local idx = 0
			// check if the item has multiple displayed states for amount
			if itdat.flags and (itdat.flags & XIF_ICONFORAMT) then 
				idx = teammate.kartstuff[k_itemamount]
			else
				idx = leveltime
			end
			patch = v.cachePatch(itdat.getItemPatchSingle(true, idx))
		end
	elseif teammate.kartstuff[k_stolentimer] > 0 then
		patch = (leveltime & 2) and patches.ghost or nil
	elseif teammate.kartstuff[k_stealingtimer] > 0 and (leveltime & 2) then
		patch = patches.ghost
	elseif teammate.kartstuff[k_eggmanexplode] > 1 then
		patch = (leveltime & 1) and patches.eggman or nil
	elseif teammate.kartstuff[k_rocketsneakertimer] > 1 then
		itembar = teammate.kartstuff[k_rocketsneakertimer]
		patch = (leveltime & 1) and patches.rocketsneaker or nil
	elseif teammate.kartstuff[k_growshrinktimer] > 1 then
		patch = (leveltime & 1) and patches.grow or nil
	elseif teammate.kartstuff[k_sadtimer] > 0 then
		patch = (leveltime & 2) and patches.sad or nil
	elseif teammate.kartstuff[k_itemamount] == 0 then
		return
	elseif (not teammate.kartstuff[k_itemheld]) or (leveltime & 1) then
		local it = teammate.kartstuff[k_itemtype]
		if pDat then
			local itdat = xItemLib.func.getItemDataById(it)
			local idx = 0
			// check if the item has multiple displayed states for amount
			if itdat.flags and (itdat.flags & XIF_ICONFORAMT) then 
				idx = teammate.kartstuff[k_itemamount]
			else
				idx = leveltime
			end
			patch = v.cachePatch(itdat.getItemPatchSingle(true, idx))
		else
			patch = patches[it]
		end
		if it == KITEM_INVINCIBILITY or it == KITEM_SPB or it == KITEM_THUNDERSHIELD then
			bg = patches.itembg2
		end
	end

	local flags = V_HUDTRANS | V_SNAPTOTOP | V_SNAPTOLEFT
	if splitscreen == 1 then
		if splitindex then flags = $ | V_SPLITSCREEN | V_SNAPTOBOTTOM end
	elseif splitscreen >= 2 then
		flags = V_HUDTRANS | (splitindex & 1 and V_SNAPTORIGHT or V_SNAPTOLEFT) | (splitindex >= 2 and V_SPLITSCREEN or V_SNAPTOTOP)
		-- bleh
		if splitindex & 1 then
			itemX, itemY = 320 - 70, -8
		else
			itemX, itemY = 24, -8
		end
	end

	v.draw(itemX, itemY, bg, flags)

	local colormap = nil
	if roulettetime then
		colormap = v.getColormap(TC_RAINBOW, teammate.skincolor)
	elseif teammate.kartstuff[k_itemblink] and (leveltime & 1) then
		colormap = v.getColormap(TC_BLINK, ({
			[0] = SKINCOLOR_WHITE,
			SKINCOLOR_RED,
			1 + (leveltime % (MAXSKINCOLORS-1))
		})[teammate.kartstuff[k_itemblinkmode]])
	end

	if teammate.kartstuff[k_itemamount] >= numberdisplaymin and not roulettetime then
		v.draw(itemX + (splitindex & 1 and 48), itemY, patches.mulsticker, flags | (splitindex & 1 and V_FLIP))
		if patch then
			v.draw(itemX, itemY, patch, flags, colormap)
		end
		v.drawString(itemX+24-(splitindex & 1 and 22), itemY+31, "x" .. teammate.kartstuff[k_itemamount], V_ALLOWLOWERCASE|flags)
	elseif patch then
		v.draw(itemX, itemY, patch, flags, colormap)
	end

	if itembar then
		local itemtime = 8*TICRATE
		local barlength = 12
		local maxl = (itemtime*3) - barlength
		local fill = (itembar*barlength)/maxl
		local length = min(barlength, fill)
		local height = 1

		v.draw(itemX+17, itemY+27, patches.itemtimer, flags)
		v.drawFill(itemX+18, itemY+18, (length == 2 and 2 or 1), height, 12|flags)

		if length > 2 then
			v.drawFill(itemX+17+length, itemY+28, 1, height, 12|flags)
			v.drawFill(itemX+19, itemY+28, length-2, 1, 120|flags)
		end
	end

	-- draw the teammate's face too!
	if teammate.mo and teammate.mo.valid then
		v.draw(itemX+(itemX > 160 and 8 or 30), itemY+12, v.cachePatch(skins[teammate.mo.skin].facemmap), flags, v.getColormap(teammate.mo.skin, teammate.mo.color))
	end
end

local spinoutstart = {}

addHook("ThinkFrame", function()
	for p in players.iterate do
		if not spinoutstart[#p] and p.kartstuff[k_spinouttimer] then
			spinoutstart[#p] = leveltime
		elseif spinoutstart[#p] and not p.kartstuff[k_spinouttimer] then
			spinoutstart[#p] = nil
		end
	end
end)

local function calcXOffsetSpinout(p, dt)
	--dont do any shake
	if not (spinoutstart[#p] or (dt == 1 and spinoutstart[#p.combi_p])) then return 0 end

	local spint = p.kartstuff[k_spinouttimer]
	if p.pflags&PF_TIMEOVER then
		spint = 0
	end
	local spintc = 0
	if dt == 1 then
		if p.combi_p.pflags&PF_TIMEOVER then
			spintc = 0
		else
			spintc = p.combi_p.kartstuff[k_spinouttimer]
		end
	end

	--figgure out some player specific vars for combi
	local t = leveltime-(spinoutstart[#p] or leveltime)
	local spinoutt = spint
	if dt == 1 then
		t = leveltime - max(spinoutstart[#p] or spinoutstart[#p.combi_p], spinoutstart[#p.combi_p] or spinoutstart[#p])
		spinoutt = max(spint or spintc, spintc or spint)
	end
	local spinoutang = FixedAngle(FixedDiv((t%(TICRATE/2)), TICRATE)*720)
	--print(spinoutang/ANG1)
	local spinoutshake = (sin(spinoutang)*spinoutt)/5
	--print(spinoutshake)
	return spinoutshake
end

local betweenSlotsHudSpace = 24

local libfunc = {}

local function xItemTeammateItem(v, p, c, itemX, itemY)
	libfunc = xItemLib.func

	local sx, sy, fflags, flip = libfunc.hudFindFlags(v, p, c)
	sx, sy = itemX, itemY
	local itemBg = v.cachePatch("K_ISBG")
	local pdat = p.xItemData
	local itdat
	local iflags = 0 -- what is the meaning of this
	if splitscreen > 1 then
		sx = $ + betweenSlotsHudSpace*(flip and -1 or 1)
	end

	local patch
	local idx = 0
	if iflags & XIF_ICONFORAMT then 
		idx = p.kartstuff[k_itemamount]
	else
		idx = leveltime
	end

	-- holding an item
	if pdat.xItem_roulette <= 0 and p.kartstuff[k_itemtype] > 0 then
		local it = p.kartstuff[k_itemtype]
		local amt = p.kartstuff[k_itemamount]
		local blinkType = p.kartstuff[k_itemblinkmode]
		itdat = libfunc.getItemDataById(it)

		local colour = v.getColormap(TC_DEFAULT, SKINCOLOR_NONE)
		if p.kartstuff[k_itemblink] and leveltime%2 == 1 then
			local localcolor = SKINCOLOR_WHITE
			if blinkType == 2 then
				localcolor = 1 + (leveltime % (MAXSKINCOLORS-1))
			elseif blinkType == 1 then
				localcolor = SKINCOLOR_RED
			end
			colour = v.getColormap(TC_BLINK, localcolor)
		elseif iflags & XIF_COLPATCH2PLAYER then 
			colour = v.getColormap(TC_DEFAULT, p.skincolor)
		end

		patch = itdat.getItemPatchSingle(true, idx)

		--draw filled box            
		v.draw(sx, sy, itemBg, V_HUDTRANS|fflags)
		v.draw(sx, sy, v.cachePatch(patch), V_HUDTRANS|fflags, colour)
		--draw amount
		if amt > 1 then
			v.drawString(sx+(flip and 2 or 24), sy+31, "x" + amt, V_ALLOWLOWERCASE|V_HUDTRANS|fflags)
		end
	-- rolling an item
	elseif pdat.xItem_roulette > 0 then
		local av
		if xItemLib.localAvailableItems and #(xItemLib.localAvailableItems[p.splitscreenindex + 1]) then
			av = xItemLib.localAvailableItems[p.splitscreenindex + 1]
		end
		local colour = v.getColormap(TC_RAINBOW, p.skincolor or SKINCOLOR_GREY)
		--roulette animation
		if av and #av > 0 then
			itdat = libfunc.getItemDataById(av[((leveltime/3 + (i+1)*2) % #av) + 1])
		else
			itdat = libfunc.getItemDataByName("KITEM_SNEAKER")
		end
		patch = itdat.getItemPatchSingle(true, idx)

		v.draw(sx, sy, itemBg, V_HUDTRANS|fflags)
		v.draw(sx, sy, v.cachePatch(patch), V_HUDTRANS|fflags, colour)
	end

	-- draw the teammate's face too!
	if pdat.xItem_roulette > 0 or p.kartstuff[k_itemtype] > 0 then
		v.draw(sx+30, sy+12, v.cachePatch(skins[p.mo.skin].facemmap), V_HUDTRANS|fflags, v.getColormap(p.mo.skin, p.mo.color))
	end
end

local function RedirectTeammateItem(v, p, c)
	local ix, iy = 42, -3
	//if not (xItemLib and p.xItemData) then
		DrawTeammateKartItem(p, v, ix, iy, c.pnum - 1)
	//else
		//xItemTeammateItem(v, p, c, ix, iy)
	//end
end

-- taken from original combi ring mod with some tweaks

local adt = 0

hcombi.PartnerHud = function(v, p, c)
	if not (hcombi.leveltime_on and p.mo and leveltime > 2) then return end
	local heart = v.cachePatch("HEART1")
	local pface = v.cachePatch(skins[p.mo.skin].facerank)
	local piframes = p.powers[pw_flashing]
	local partnerface = v.cachePatch("UKRNK1")
	local partneriframes = 0
	local colmap = v.getColormap(p.mo.colorized and TC_RAINBOW or p.mo.skin, p.mo.color)
	local partnervalid = p.combi ~= nil and p.combi_p and p.combi_p.valid and p.combi_p.mo
	local colmap_p = partnervalid and v.getColormap(p.combi_p.mo.colorized and TC_RAINBOW or p.combi_p.mo.skin, p.combi_p.mo.color)

	local splitindex = c.pnum - 1 -- not documented anywhere...

	if p.has_partner and leveltime >= finishtime then
		heart = v.cachePatch("HEART2")
		if partnervalid then
			partnerface = v.cachePatch(skins[p.combi_p.mo.skin].facerank)
			partneriframes = p.combi_p.powers[pw_flashing]
		end
	elseif not p.has_partner and leveltime >= finishtime then
		heart = v.cachePatch("HEART1")
	elseif leveltime >= 2 then
		heart = v.cachePatch("HEART2")
		partnerface = v.cachePatch("UKRNK1")
	end

	local combiname, nextcombiname = "---", "---"
	if p.fake_combi and p.fake_combi.valid then
		combiname = p.fake_combi.name
	end
	if p.old_combi and p.old_combi.valid then
		nextcombiname = p.old_combi.name
	end

	-- gargoyle or partner name?
	if leveltime > finishtime and (not p.has_partner or partnervalid) then
		combiname = p.combi_p.name
	end

	local scroll = FixedMul(FixedDiv(hcombi.initscroll, 6*TICRATE), 10)

	local ypos = 120
	local xpos = 160
	local width = v.width()/v.dupx()
	local flags = V_SNAPTOBOTTOM
	if splitscreen == 1 then
		ypos = 61
		flags = splitindex and V_SPLITSCREEN | V_SNAPTOBOTTOM
	elseif splitscreen >= 2 then
		ypos = 61
		flags = 0
		-- must center the x coordinate
		local xofs = (width - 320)/4
		width = $ / 2
		if splitindex & 1 then
			flags = $ | V_HORZSCREEN
			xofs = -xofs
		end
		if splitindex >= 2 then
			flags = $ | V_SPLITSCREEN | V_SNAPTOBOTTOM
		end
		xpos = $ - xofs - 80
	end

	local halftrans = flags
	-- respect the player's transparency setting after partner has been selected
	if leveltime > finishtime + 35 then
		halftrans = $ | V_50TRANS + ((v.localTransFlag() >> 1) & V_ALPHAMASK)
		flags = $ | v.localTransFlag()
	else
		halftrans = $ | V_50TRANS
	end

	ypos = $ + (min(max(leveltime - (finishtime+35), 0), 20) / (splitscreen and 3 or 1))

	-- gray background
	if leveltime <= finishtime then
		v.drawFill(xpos - width/2, ypos - 3, width, 14, 24|flags)
	end

	if p.old_combi and scroll > 0 then
		v.drawString(xpos + 10, ypos + 10 - scroll + adt, nextcombiname, V_ALLOWLOWERCASE|flags, leveltime >= finishtime and "thin" or "left")
	end

	adt = leveltime > finishtime and min(adt+1, 7) or 0

	-- player name
	v.drawString(xpos - 10, ypos+adt, p.name, V_ALLOWLOWERCASE|flags, leveltime > finishtime and "thin-right" or "right")
	-- partner name
	v.drawString(xpos + 10, ypos - scroll + adt, combiname, V_ALLOWLOWERCASE|flags, leveltime > finishtime and "thin" or "left")

	-- picking a partner
	if leveltime <= finishtime then
		local color = min(leveltime & 31, 31 - (leveltime & 31)) + 160
		v.drawFill(xpos - width/2, ypos - 9, width, 6, color|flags)
		v.drawFill(xpos - width/2, ypos + 11, width, 6, color|flags)

		if splitscreen == 0 then
			for i = -16,16 do
				v.drawString((80 - (leveltime - finishtime))+(80*i),ypos-21, "Please wait...", halftrans | V_ALLOWLOWERCASE, "thin")
				v.drawString((80 + (leveltime - finishtime))-(80*i),ypos+19, "Please wait...", halftrans | V_ALLOWLOWERCASE, "thin")
			end
		end
	end

	-- <3
	v.draw(xpos - (21/2), ypos + (25/2), heart, halftrans)

	-- player face
	
	local pflags = flags
	
	if (flags & V_HUDTRANS) ~= 0 and piframes > 0 and ((piframes / 2) % 2 == 1) then
		pflags = ($ & ~V_HUDTRANS) | V_HUDTRANSHALF
	end
	
	v.draw(xpos - 25 + FixedInt(calcXOffsetSpinout(p, 0)), ypos + (25/2) + 4, pface, pflags, colmap)

	local partnerflags = flags
	
	if (flags & V_HUDTRANS) ~= 0 and partneriframes > 0 and ((partneriframes / 2) % 2 == 1) then
		partnerflags = ($ & ~V_HUDTRANS) | V_HUDTRANSHALF
	end

	-- partner face
	local addi = p.has_partner and partnervalid and FixedInt(calcXOffsetSpinout(p.combi_p, 0)) or 0
	v.draw(xpos + (21/2) + addi, ypos + (25/2) + 4, partnerface, partnerflags, colmap_p or nil) -- pop quiz: what does ``false or nil`` return?

	if p.has_partner and partnervalid then RedirectTeammateItem(v,p.combi_p,c) end
end

hud.add(hcombi.PartnerHud)