// hcombi 2.0

if hcombi then return end // already loaded

// shill
print("\x88".."-----------------------------------------------------------")
print("\x89".."Haya's Combi Ring has successfully been loaded!")
print("\x88".."2.0 BETA BUILD - WILL HAVE BUGS")
print("")
print("\x8C".."Please contact merlinsotrue on Discord about bugs/problems.")
print("\x88".."-----------------------------------------------------------")

// we are back
rawset(_G, "hcombi", {

	// METADATA/INFO
	MAJOR_VERSION = 2, // major
	MINOR_VERSION = 0, // minor

	// we are on!
	enabled = nil, // set later
	leveltime_on = 0, // the above but set during race start
	
	// GAMEPLAY SHIZ
	
	initscroll = 0, // for partner assignment
	Chains = {}, // chain stuff, see chains.lua
	
	// VARIOUS STUFF
	
	// friends
	frens_allowed = CV_RegisterVar({
		name = "combi_allowfriends",
		defaultvalue = "On",
		flags = CV_NETVAR,
		possiblevalue = CV_OnOff
	}),
	
	// friendly fire
	friendlyfire = CV_RegisterVar({
		name = "combi_friendlyfire",
		defaultvalue = "Off",
		flags = CV_NETVAR,
		possiblevalue = CV_OnOff
	}),
	
	// minimum players
	minimumplayers = CV_RegisterVar({
		name = "combi_minimumplayers",
		defaultvalue = 2,
		flags = CV_NETVAR,
		possiblevalue = CV_Natural
	})
	
}) // hcombi global namespace

// currently only karteliminatelast
local tracked = {
	{dep = true, var = "karteliminatelast", pref = 0, alt = "combieliminatelast"}
}

// taken from jukebox (hi tyron)
local function hcombi_setup()
	if not server then return end
	if replayplayback then return end
	if (consoleplayer) and (consoleplayer != server) then return end
	CONS_Printf(server, ">> Beginning combi ring cvar setup.")
	CONS_Printf(server, ">> You may see this multiple times, the console is slow and config is weird.")
	for k, v in ipairs(tracked)
		if CV_FindVar(v.var)
			if CV_FindVar(v.var).value != v.pref
				CONS_Printf(server, "* Changing "..v.var.." to "..v.pref.."...")
				if v.alt then
					CONS_Printf(server, "* Use "..v.alt.." instead of "..v.var.."!")
				else
					tracked[k].saved = CV_FindVar(v.var).value
				end
				CV_Set(CV_FindVar(v.var), v.pref)
			end
		else
			if v.dep then
				CONS_Printf(server, "* Couldn't find "..v.var.."! Please update SRB2Kart.")	
			end
		end
	end
end

local function hcombi_restore()
	if not server then return end
	if replayplayback then return end
	if (consoleplayer) and (consoleplayer != server) then return end
	CONS_Printf(server, ">> Reverting changes combi ring made to cvars during setup.")
	for k, v in ipairs(tracked)
		if v.saved != nil
			CONS_Printf(server, "* Changing "..v.var.." back to "..v.saved.."...")
			CV_Set(CV_FindVar(v.var), v.saved)
			v.saved = nil
		end
	end
end

// we are so back
hcombi.enabled = CV_RegisterVar({
	name = "combi_active",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CALL,
	possiblevalue = CV_OnOff,
	func = function(var)
		if var.value then
			hcombi_setup()
		else
			hcombi_restore()
		end
	end
})

-- replacement for karteliminatelast
hcombi.combieliminatelast = CV_RegisterVar({
	name = "combieliminatelast",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
})